# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# DCluste.R
# 20110425


## ԃXL
library(DCluster)
library(spdep)
data(nc.sids)
sids <- data.frame(Observed = nc.sids$SID74)
sids <- cbind(sids, Expected = nc.sids$BIR74*
  sum(nc.sids$SID74)sum(nc.sids$BIR74))
sids <- cbind(sids, x = nc.sids$x, y = nc.sids$y)
head(sids)

dist <- (sids$x - sids$x[1])^2 + (sids$y - sids$y[1])^2
index <- order(dist)

kullnagar.stat(sids[index, ], fractpop = 0.5)

all <- sapply(1:100, function(n) {
    dist <- (sids$x - sids$x[n])^2 + (sids$y -
        sids$y[n])^2
    index <- order(dist)
    kullnagar.stat(sids[index, ], fractpop = 0.5)
})

all <- t(all)
all[which.max(all[, 1]), ]

which.max(all[, 1])

row.names(nc.sids[which.max(all[, 1]), ])


## œ_𓖂ĂԏWϐ̌
st.pgboot <- boot(sids, statistic = stone.pboot,
    sim = "parametric", ran.gen = negbin.sim,
    R = 999, region = 85)
print(st.pgboot)

plot(st.pgboot)

stone.test(Observed ~ offset(log(Expected)), sids,
    model = "negbin", R = 999, region = 85)
