# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# bigmemory.R
# 20110425

# DATA Expo 2009 Web y[W
# ihttp://stat-computing.org/dataexpo/2009/supplemental-data.htmlj
# 
# NƂ̃f[^t@C肵C1 ̃t@Cɂ܂Ƃ߁C
# gAirlineDataAll.csvhƂt@Cŕۑ܂B
# ܂C̃t@C9 ڂ̃LAR[hC11 ڂ̋@̃R[hC
# 17 ڂ̏o`R[hC18 ڂ̓`R[h͕ƂȂĂ܂B
# bigmemory ł́Č^݂łȂ߁Cꂼ̃R[h\ł
# gcarriers.csvhCgplane-data.csvhCgairports.csvh擾C
# lɕϊĂKv܂B

library(bigmemory)
library(biganalytics)
library(bigtabulate)



## bIȕ
airline <- read.big.matrix("AirlineDataAll.csv",
                           header=TRUE, type="integer",
                           backingfile="AirlineDataAll.bin",
                           descriptorfile="AirlineDataAll.desc")

airline <- attach.big.matrix("AirlineDataAll.desc")

airline

airline[1:3, 1:5]

deptime <- airline[,"DepTime"]

dim(airline) # f[^TCY̊mF
head(airline, 3) # 擪3 s
tail(airline, 3) # 3 s

# e̗v( ŏl, ől, ϒl,NA ̐)
summary(airline)
# e, ej̃tCg
bigtable(airline, c("Month", "DayOfWeek"))
# eNx̓Ԓx̓v( ŏl, ől, ϒl, W΍,NA ̐)
bigtsummary(airline, "Year", cols="ArrDelay", na.rm=T)

airline.lm.res <- biglm.big.matrix(ArrDelay ~ DepDelay + Distance, data=airline) # `A
summary(airline.lm.res) # v
AIC(airline.lm.res) # AIC



## vZ
library(bigmemory)
# xꎞԂ̕ʓ_Zo֐
GetArrDelayQuantiles <- function (rows, data) {
  return(quantile(data[rows, "ArrDelay"],
  probs=c(0.25, 0.5, 0.75, 0.9, 0.99), na.rm=TRUE ))
}
airline <- attach.big.matrix("AirlineDataAll.desc")
groups <- split(1:nrow(airline), airline[,"DayOfWeek"])
# eq@̍sԍ̔o
qs.s <- sapply(groups, GetArrDelayQuantiles, data=airline)
# ej̓xꎞԂ̕ʓ_


install.packages(foreach); library(foreach)
install.packages(doSNOW); library(doSNOW)
# 4 RAgĕvZs
cl <- makeSOCKcluster(4)
registerDoSNOW(cl)
al.desc <- describe(airline)
qs.f <- foreach (g=groups, .combine=rbind) %dopar% {
    require(bigmemory)
    al <- attach.big.matrix(al.desc)
    GetArrDelayQuantiles(g, data=al)
}
