# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# glmnet.R
# 20110425


data(cars, package="caret")
options(warn=-1)
cars.glmnet <- glmnet(as.matrix(cars[,-1]), cars[,1])
plot(cars.glmnet)

cars.cv.glmnet <- cv.glmnet(as.matrix(cars[,-1]), cars[,1])
predict(cars.glmnet, as.matrix(cars[,-1]),
        s=cars.cv.glmnet$lambda.min)

match(cars.cv.glmnet$lambda.min, cars.glmnet$lambda)
cars.glmnet$beta[,65]

summary(as.matrix(cars[,-1]) %*% cars.glmnet$beta[,65])

boxplot(as.matrix(cars[,-1]) %*% cars.glmnet$beta[,65])


## l
data(mdrr, package="caret")
mdrr.glmnet <- glmnet(as.matrix(mdrrDescr), mdrrClass,
                     family="binomial")
plot(mdrr.glmnet)

mdrr.cv.glmnet <- cv.glmnet(as.matrix(mdrrDescr), mdrrClass,
                            family="binomial")
table(as.numeric(mdrrClass), predict(mdrr.glmnet,
      as.matrix(mdrrDescr),
      s=mdrr.cv.glmnet$lambda.min,
      type="class"))

idx <- match(mdrr.cv.glmnet$lambda.min, mdrr.glmnet$lambda)
boxplot(list(active=as.matrix(
        mdrrDescr[mdrrClass == "Active",]) %*%
        mdrr.glmnet$beta[,idx],
        inactive=as.matrix(mdrrDescr[mdrrClass == "Inactive",]) %*%
        mdrr.glmnet$beta[,idx]))


## l
iris.glmnet <- glmnet (as.matrix(iris[,-5]), iris[,5],
                       family="multinomial")
par(mfrow=c(2, 2))
plot(iris.glmnet)

iris.cv.glmnet <- cv.glmnet(as.matrix(iris[,-5]), iris[,5],
                            family="multinomial")
table(iris[,5],predict(iris.glmnet, as.matrix(iris[,-5]),
                       s=iris.cv.glmnet$lambda.min, type="class"))
