# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# gmm.R
# 20110425


## 1D{YifiCAPM: Capital Asset Pricing Modelj̐
library(gmm)
data(Finance)
dim(Finance)
head(Finance,3)

r <- Finance[1:300, 1:10]
rm <- Finance[1:300, "rm"]
rf <- Finance[1:300, "rf"]

z <- as.matrix(r - rf)
zm <- rm - rf
t <- nrow(z)
h <- matrix(zm, t, 1)

res <- gmm(z ~ zm, x = h)
summary(res)

library(car)
R <- cbind(diag(10), matrix(0,10,10))
c <- rep(0,10)
linearHypothesis(res, R, c, test = "Chisq")

res1 <- gmm(z ~ zm - 1, x = cbind(1, h))
specTest(res1)


## 2DGEL pKz̃p[^̐
set.seed(123) # ̎̎w
n <- 200
x <- rnorm(n, mean = 4, sd = 2)
g1 <- function(tet, x) {
    m1 <- (tet[1] - x)
    m2 <- (tet[2]^2 - (x - tet[1])^2)
    m3 <- x^3 - tet[1] * (tet[1]^2 + 3 * tet[2]^2)
    f <- cbind(m1, m2, m3)
    return(f)
}

tet0 <- c(mu = mean(x), sigma = sd(x))
res_el <- gel(g1, x, tet0)
summary(res_el)
