# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# rgdal.R
# 20110425


## EPSG ԍ̌
library(rgdal)
EPSG <- make_EPSG()
EPSG[grep("JGD2000", EPSG$note), 1:2]


## 􉽕ϊ
scot_BNG <- readOGR(system.file("vectors",
     package = "rgdal")[1], "scot_BNG")

proj.sco <- proj4string(scot_BNG)
proj.sco

scot_LL <- spTransform(scot_BNG,
    CRS("+proj=longlat +datum=WGS84"))

grd_LL <- gridlines(scot_LL, ndiscr = 100)

grd_BNG <- spTransform(grd_LL, CRS(proj.sco))

grdtxt_LL <- gridat(scot_LL)

grdtxt_BNG <- spTransform(grdtxt_LL, CRS(proj.sco))

op <- par(mfrow = c(1, 2))
plot(scot_LL, axes = TRUE)
plot(scot_BNG, axes = TRUE, las = 1)
plot(grd_BNG, add = TRUE, lty = 2)
text(coordinates(grdtxt_BNG),
     labels = parse(text = as.character(grdtxt_BNG$labels)))
par(op)
