# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# rtiff.R
# 20110425


## TIFF t@C̓ǂݍ
library(rtiff)
(tif.path <- system.file("tiff", "t1.tif", package="rtiff"))
# pXOS Ɉˑ܂B

getDescription(fn=tif.path)

(tif.t1 <- readTiff(fn=tif.path))

str(tif.t1)

plot(tif.t1, main="raw pixmap image/nconverted from 't1.tiff'")
# ׂẴC\
plot(tif.t1@red, main="red channel image/n
     from raw pixmap image") #red \
range(tif.t1@red)


## TIFF t@C̃f[^
x <- density(tif.t1@red)
plot(x, col=2, xlim=c(0, 1), ylim=c(0, 3),
     main="deinsity plot of 3 rasters")
lines(density(tif.t1@blue, bw=x$bw), col=4)
lines(density(tif.t1@green, bw=x$bw), col=3)

layout(t(1:2))
x <- apply(tif.t1@red, 1, mean)
plot(x, col=2, ylim=c(0, 1), type="l",
     xlab="An ordinate of pixmap", ylab="Intensity",
     main="average signal intensity")
lines(apply(tif.t1@blue, 1, mean), col=4)
lines(apply(tif.t1@green, 1, mean), col=3)
x <- apply(tif.t1@red, 2, mean)
plot(x, col=2, ylim=c(0, 1), type="l",
     xlab="An abscissa of pixmap", ylab="Intensity",
     main="average signal intensity")
lines(apply(tif.t1@blue, 2, mean), col=4)
lines(apply(tif.t1@green, 2, mean), col=3)

tif.r <- tif.t1@red
tif.r[tif.r<.4 | tif.r>=.6] <- 0 # Ԃ͈̔͊O0 ɂ
tif.b <- tif.t1@blue
tif.b[tif.b<.6] <- 0 # ͈̔͊O0 ɂ
tif.g <- tif.t1@green
tif.g[tif.g>=.4] <- 0 # ΂͈̔͊O0 ɂ
tif.mix <- tif.r * tif.b * tif.g!=0
# , , ΂S0 łȂGA𒊏o
tif.r[tif.mix] <- tif.b[tif.mix] <- tif.g[tif.mix] <- 1
tift1.new <- newPixmapRGB(red=tif.r, green=tif.g, blue=tif.b)
# VIuWFNg̐
plot(tift1.new, main=expression(
     .4<=Red~phantom()<.6~and~Blue>=.6~and~Green<.4))


## TIFF t@C̏o
writeTiff(pixmap=tift1.new, fn="t1new.tif")
updateDescription(fn="t1new.tif", description=
     "A red is greater than and eual to .4, and less than .6.\n
      A blue is greater than and equal to .6.\n
      A green is less than .4.")
getDescription(fn="t1new.tif") # Ô߂ɊmF
