# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# survival.R
# 20110425


## f[^̏
library(survival)
colon.OS <- subset(colon, colon$etype==2)


## Kaplan-Meier @ɂ鐶ԕz̐
result.KM <- survfit(Surv(time,status)~rx,data=colon.OS)
result.KM

plot(result.KM, lty=1:3, xlim=c(0, 3500), ylim=c(0, 1),
     xlab="Time", ylab="Event Free Rate", main="Survival Curve")
abline(0.5, 0)
legend(2000, 1.0, legend=c("Obs","Levamisole","Levamisole+5-
       FU"), lty=1:3, bty="n")
plot(result.KM, lty=1:3, fun="cloglog", xlab="Time",
     ylab="log(-log(Event Free Rate))", main="Log-log Curve")
legend(20, 0, legend=c("Obs","Levamisole","Levamisole+5-FU"),
       lty=1:3, bty="n")

censor <- data.frame(result.KM$time, result.KM$surv, result.
                     KM$n.event)
plot(result.KM, lty=1:3, xlim=c(0, 3500), ylim=c(0, 1),
     xlab="Time", ylab="Event Free Rate", main="Survival Curve",
     mark.time=FALSE)
abline(0.5, 0)
legend(2000, 1.0, legend=c("Obs","Levamisole","Levamisole+5-
       FU"), lty=1:3, bty="n")
for (i in 1:nrow(censor)){
     if (censor$result.KM.n.event[i]==0) {
         segments(censor$result.KM.time[i],
         censor$result.KM.surv[i], censor$result.KM.time[i],
         censor$result.KM.surv[i]+0.01)
     }
}


## ONɂ鐶ԕz̔r
result.LR <- survdiff(Surv(time,status)~rx,
             subset=(rx %in% c("Obs", "Lev+5FU")), data=colon.OS)
result.LR


## Cox nU[hfɂnU[h̐
result.Cox <- coxph(Surv(time,status)~rx+node4+age+obstruct+pe
    rfor+adhere+nodes+differ+extent+surg+node4,
    method="breslow", data=na.omit(colon.OS))
summary(result.Cox)

result.coxzph <- cox.zph(result.Cox)
result.coxzph
plot(result.coxzph, var="differ")

library(MASS)
result.step <- stepAIC(result.Cox)

summary(result.step)
