# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# Epi.R
# 20110425
library(Epi)


## Lexis IuWFNg
data(nickel)
nicL <- Lexis( entry = list( per=agein+dob,
                             age=agein, tfh=agein - age1st ),
               exit = list( age=ageout ),
               exit.status = ( icd %in% c(162,163) ) *1,
                               data = nickel )

head(nicL)



## tH[Abvf[^̑w
nicS1 <- splitLexis( nicL, "age", breaks=seq(0,100,10) )
head(subset(nicS1, age == 50))

nicC <- cutLexis(data=nicL, cut=20, timescale="tfh",
                 new.state=2, precursor.states=0)

subset(nicL,lex.id==14)

subset(nicC,lex.id==14)
