# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# R2WinBUGS.R
# 20110425

library(BRugs)
library(R2WinBUGS)

## 1FWinBUGS Ƃ̘Ag
model.file <- system.file(package="R2WinBUGS", "model",
                          "schools.txt")
file.show(model.file) # t@C̒g̊mF

data(schools)
schools # f[^Zbg̊mF
J <- nrow(schools)
y <- schools$estimate
sigma.y <- schools$sd
data <- list ("J", "y", "sigma.y")
inits <- function() {
   list(theta=rnorm(J, 0, 100), mu.theta=rnorm(1, 0, 100),
        sigma.theta=runif(1, 0, 100))
   }
parameters <- c("theta", "mu.theta", "sigma.theta")
# WinBUGS CXg[tH_w
BugsDir <- "C:/programs/WinBUGS14/"
BugsWD <- getwd()

schools.sim <- bugs(data, inits, parameters, model.file,
    n.chains=3, n.iter=5000,
    bugs.directory=BugsDir,
    working.directory=BugsWD)
print(schools.sim)
plot(schools.sim)


## 2FOpenBUGS Ƃ̘Ag
# bugs ֐Ăяo܂ł̏́CWinBUGS ̏ꍇƓ
schools.sim <- bugs(data, inits, parameters, model.file,
                    n.chains=3, n.iter=5000, program="OpenBUGS")
