# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# Rmetrics.R
# 20110425


source("http://www.rmetrics.org/Rmetrics.R")
install.Rmetrics()


## fOptions pbP[W̎gp
library(fOptions)
price.stock <- 62
price.strike <- 60
maturity <- 0.5
volatility <- 0.2
interest.rate <- 0.1

# R[IvVivZiS4 IuWFNgԂĂj
option.call <- GBSOption(TypeFlag = "c", S = price.stock,
                 X = price.strike ,Time = maturity,r = interest.rate,
                 sigma = volatility, b = interest.rate)
# IvV̉i擾
option.call@price

# IvṼXNwWvZif^ƃK}j
GBSGreeks(Selection = "delta", TypeFlag = "c", S = price.stock,
          X = price.strike ,Time = maturity,r = interest.rate,
          sigma = volatility, b = interest.rate)
GBSGreeks(Selection = "gamma", TypeFlag = "c", S = price.stock,
          X = price.strike ,Time = maturity,r = interest.rate,
          sigma = volatility, b = interest.rate)
GBSCharacteristics(TypeFlag = "c", S = price.stock,
                   X = price.strike ,Time = maturity,r = interest.rate,
                   sigma = volatility, b = interest.rate)

# IvVi͐قǌvZR[IvVi
GBSVolatility(price = option.call@price,TypeFlag = "c",
              S = price.stock, X = price.strike,
              Time = maturity,r = interest.rate, b = interest.rate)


## fImports pbP[W̎gpivC^[lbgڑj
library(fImport)
#10 Nf[^擾iftHgƒ1 N擾j
interest.rate <- fredSeries("DGS10")

interest.rate <- fredSeries(symbols = "DGS10",=
                            from "2007-01-01",to = Sys.timeDate())
plot(interest.rate)

## fGarch pbP[W̎gp
library(fGarch)
# ftHgGARCH(1,1) fIB1000 ̃f[^쐬
#  ,  , ւ͂ꂼ0.1,0.8,1e-6 Ɛݒ肳
garch.spec <- garchSpec()
garch.spec
garch.sim <- garchSim(spec = garch.spec, n = 1000)
#timeSeries IuWFNgƂĐ
head(garch.sim)
class(garch.sim)
#GARCH(1,1) fƂĐf[^p[^[tɐv
garch.fit <- garchFit( ~ garch(1, 1), data = garch.sim,
                      trace = FALSE)
# GARCH(1,1) f琶ꂽ{eBeB擾ɂ
# volatility ֐g
volatility(garch.fit, type = "sigma")
#type IvVŎw肷ƕUł̎擾\
volatility(garch.fit, type = "h")

# ۂ̋Znf[^𕪐
library(fImport)
#S&P500 Index f[^擾 & ^[niZpEjɕϊ
sp500.index <- fredSeries("SP500",from = "2008-01-01")
sp500.return <- sp500.index / lag(sp500.index)-1
sp500.return <- sp500.return[!is.na(sp500.return),]
# 񖼂𖾋L garchFit(SP500 ~ garch(1, 1), data = sp500.
# return, trace = FALSE) ƏĂ
sp500.fit <- garchFit( ~ garch(1, 1), data = sp500.return,
trace = FALSE)
#summary ֐Ō蓝vʂʋK`FbNł
#iӁIjGARCH(1,1) ŒuĂ܂,
#ۂɂ͂̒lĂӂ킵 GARCH f̎肷B
# ܂, ʋKɊւĂsp500.fit@fit$ics 
# NX擾Ă擾\
summary(sp500.fit)
#S&P500 ̃^[Ƃ̃{eBeBiGARCH lj
# [}VbNEMVA@ߕӂ
# {eBeB}Ălq킩Ǝv܂B
plot(cbind(sp500.return,volatility=volatility(sp500.fit,
     type = "sigma")))
