# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# ccgarch.R
# 20110425


library(ccgarch)
library(RFinanceYJ)
library(vars) # zoo pbP[WȂǂtă[h

hitachi <- quoteStockTsData('6501.t', since='1998-04-01')
toshiba <- quoteStockTsData('6502.t', since='1998-04-01')
mitsubishi <- quoteStockTsData('6503.t', since='1998-04-01')

d.index <- as.Date(toshiba$date)
kabuka <- zoo(cbind(hitachi$close, toshiba$close,
              mitsubishi$close), d.index)
colnames(kabuka) <- c("", "", "OH")

returns <- 100*diff(log(kabuka))
nobs <- dim(returns)[1] # Tv T
ndim <- dim(returns)[2] # f̎ N
par(cex.axis=1.5, cex.lab=2)
plot(returns, main="d@3Ђ̊v", xlab="")

select.lag <- VARselect(returns, type="const", lag.max=20)
# AIC ɂVAR f̃O
nlag <- select.lag$selection[1]
# IꂽO=4
nlag
var.model <- VAR(returns, p=nlag)
# VAR f̂Ă͂
eps <- residuals(var.model)
# VAR c̕ۑ
d.index <- index(returns)
# VtpCfbNX
eps <- zoo(eps, d.index[(nlag+1):nobs])
# czoo IuWFNgɕϊ

stats <- round(rbind(
          colMeans(eps),
          c(max(eps[,1]), max(eps[,2]), max(eps[,3])),
          c(min(eps[,1]), min(eps[,2]), min(eps[,3])),
          sd(eps),
          rob.sk(eps),
          rob.kr(eps)
         ), 3)
stats <- rbind(rep(dim(eps)[1], 3), stats)
rownames(stats) <- c("nobs", "mean", "maximum", "minimum",
         "s.d.", "std. sk", "rob. sk", "std. kr ", "rob. kr")
stats

nt.test(eps)
hh.test(eps)

# p[^l̐ݒ
a <-        c(0.003, 0.005, 0.001)
A <- matrix(c(0.2  , 0.002, 0.001 ,
              0.001, 0.3  , 0.0005,
              0.003, 0.005, 0.15   ), 3, 3, byrow=T)
B <- matrix(c(0.75 , 0.0001, 0.0015,
              0.002, 0.6   , 0.0003,
              0.001, 0.008 , 0.8    ), 3, 3, byrow=T)
dcc.para <- c(0.1, 0.8)

edcc.results <- dcc.estimation(inia=a, iniA=A, iniB=B,
             ini.dcc=dcc.para, dvar=eps, model="extended")

round(edcc.results$out, 3)

Ind <- matrix(1:ndim^2, ndim, ndim)
DCC <- zoo(edcc.results$DCC[, Ind[lower.tri(Ind)]],
           d.index[(nlag+1):nobs])
colnames(DCC) <- c("-","-OH","-OH")
h <- zoo(edcc.results$h, d.index[(nlag+1):nobs])
colnames(h) <- c("", "", "OH")
plot(DCC, main="I֌W")
plot(sqrt(h), main="{eBeB")
