# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# coda.R
# 20110425

library(coda)
library(MCMCpack)

## 1FMCMCpack pbP[Wɂ鐄茋ʂ̊mF
X <- rnorm(1000, 0, sqrt(10))
Z <- 1.0 - 2.0 * X + rnorm(1000)
Y <- rep(0, 1000)
Y[which(Z > 0)] <- 1
dataset <- data.frame(X, Y)

posterior <- MCMCprobit(Y ~ X, data = dataset, burnin = 3000,
                        mcmc = 30000)

class(posterior)

summary(posterior)
plot(posterior)
geweke.diag(posterior)

geweke.diag(posterior)


## 2FWinBUGS{R2WinBUGS pbP[Wɂ鐄茋ʂ̊mF
library(R2WinBUGS)
probitmodel <- function(){
       for (i in 1:I){
         Y[i] ~ dbern(p[i])
         p[i] <- phi(alpha + beta*X[i])
       }
       alpha ~ dnorm (0.0, 1.0E | 6)
       beta ~ dnorm (0.0, 1.0E | 6)
}
write.model(probitmodel, "probit.txt")

I <- length(Y)
data <- list ("I", "Y", "X")
inits <- function() list(alpha = 0, beta = 0)
parameters <- c("alpha", "beta")
# WinBUGS CXg[tH_w
BugsDir <- "C:/programs/WinBUGS14/"
BugsWD <- getwd()
rslt.bugs <- bugs(data, inits, parameters, "probit.txt",
    n.chains=3, n.iter=5000, codaPkg = TRUE,
    bugs.directory=BugsDir,
    working.directory=BugsWD)
rslt.mcmc <- read.bugs(rslt.bugs)

summary(rslt.mcmc)
plot(rslt.mcmc)
geweke.diag(rslt.mcmc)
gelman.diag(rslt.mcmc)
