# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# e1071.R
# 20110425

library("e1071")

## svm ֐ɂl
iris.svm.setosa <- svm(subset(iris, Species == "setosa")[,-5])
print(iris.svm.setosa)

set.seed(123)
predict(iris.svm.setosa,
        subset(iris, Species == "setosa")[sample(1:50, 10), -5])

any(predict(iris.svm.setosa,
    subset(iris, Species != "setosa")[, -5]))


## svm ֐ɂ鑽l
iris.svm <- svm(iris[,-5], iris[,5])

iris.svm <- svm(Species ~ ., data=iris, kernel="radial")

print(iris.svm)

table(iris[,5], predict(iris.svm, iris[,-5]))

iris.svm.s <- svm(iris[,-5], iris[,5], kernel="sigmoid")
table(iris[,5], predict(iris.svm.s, iris[,-5]))

iris.svm.p = svm(iris[,-5], iris[,5], kernel="polynomial")
table(iris[,5], predict(iris.svm.p, iris[,-5]))

iris.svm.l = svm(iris[,-5], iris[,5], kernel="linear")
table(iris[,5], predict(iris.svm.l, iris[,-5]))


## p[^̃`[jO
iris.svm.tune <- tune.svm(Species~., data = iris,
                          gamma = 2^(-3:-1), cost = 2^(-1:1))

summary(iris.svm.tune)

plot(iris.svm.tune)

iris.svm.best <- svm(iris[,-5], iris[,5], cost=2, gamma=0.125)
table(iris[,5], predict(iris.svm.best, iris[,-5]))


## svm ֐ɂA
data(BloodBrain, package="caret")
(bbbDescr.svm <- svm(bbbDescr, logBBB))

set.seed(123)
predict(bbbDescr.svm, bbbDescr[sample(1:length(bbbDescr),6),])


## SVM f̃t@Cւ̏o
svmfilenmame <- tempfile()
scalefilenmame <- tempfile()
write.svm(iris.svm, svm.file=svmfilenmame,
          scale.file=scalefilenmame)
head(readLines(svmfilenmame), 11)
