# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# maptools.R
# 20110425


## RvX}
library(maptools)
map <- readShapeSpatial(system.file("shapes/sids.shp",
           package = "maptools")[1], IDvar = "FIPSNO",
           proj4string = CRS("+proj=longlat +ellps=clrk66"))
class(map)
names(map)

m <- with(map@data, SID74/BIR74) * 1000
cols <- grey(6:2/6)
brks <- c(-Inf, 2, 4, 6, 8, Inf)
plot(map, col = cols[findInterval(m, brks,
     all.inside = TRUE)])

legend("bottomleft", fill = cols, legend = leglabs(brks),
       title = "Mortality of SIDS", bty = "n")

summary(map)

map1 <- map[map$CNTY_ID < 1982, ]
map2 <- map[map$CNTY_ID >= 1982, ]

map3 <- spRbind(map2, map1)

op <- par(no.readonly = TRUE)
par(mfrow = c(1, 3), mai = c(0, 0, 0.5, 0))
plot(map1)
title(main = "map1")
plot(map2)
title(main = "map2")
plot(map3)
title(main = "map3")
par(op)

plot(map1, xlim = c(-83, -80), ylim = c(35.5, 36.5), axes = TRUE)
pointLabel(coordinates(map1), labels = map1$NAME)
