# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# nnet.R
# 20110425


## j[lbg[Nf̍\z
set.seed(123)
library(nnet)
table(iris$Species) #3 i50 Tv
train.ind <- sapply(unique(iris$Species), function(x)
             sample(rownames(subset(iris, subset=Species==x)), 40))
train <- iris[as.numeric(train.ind),]
test <- iris[-as.numeric(train.ind),]

model.nn <- nnet(Species~., data=train, size=3, maxit=100)
# subset gꍇ,
# nnet(Species~., data=iris, size=3, subset=as.numeric(train.ind))
# weights: 27


## f̊mF
summary(model.nn) # print(model.nn) ƔׂĂB

source("http://hosho.ees.hokudai.ac.jp/~kubo/log/2007/img07/plot.nn.txt")
plot.nn(model.nn)


## wKfp\
head(test, 3)
pred.nn <- predict(model.nn, test)
head(pred.nn, 3)

head(apply(pred.nn, 1, function(x) colnames(pred.nn)[which.is.max(x)]))

head(pred.nn.cl <- predict(model.nn, test, type="class"))

table(test$Species, pred.nn.cl)


## NXof[V
dat <- subset(iris, subset=Species!="setosa")
dat$Species <- factor(dat$Species, levels=c("versicolor","virginica"))
nnet.cv <- NULL
for(i in 1:nrow(dat)){
 test <- dat[i,]
 train <- dat[-i,]
 model.cv <- nnet(Species~., data=train, size=2, maxit=50)
 nnet.cv <- rbind(nnet.cv, predict(model.cv, test))
}
head(nnet.cv)

(x <- table(dat$Species, nnet.cv>.5))
sum(diag(x))/sum(x)

library(Epi)
ROC(test=nnet.cv, stat=dat$Species, plot="ROC")


## WXeBbNAf̏ꍇ
train.ind <- sapply(unique(iris$Species), function(x)
      sample(rownames(subset(iris, subset=Species==x)), 40))
train <- iris[as.numeric(train.ind), ]
test <- iris[-as.numeric(train.ind),]
model.mu <- multinom(Species~., data=train)
summary(model.mu)

pred.mu <- predict(model.mu, test)
table(test$Species,as.character(pred.mu))


## j[lbgf̕`֐삷ȂH
library(diagram)
name <- list(i=attr(model.nn$term, "term.labels"),
             h=paste("h", seq(model.nn$n[2]), sep=""), o=model.nn$lev)
value <- data.frame(con=model.nn$conn, w=model.nn$wts)
i2h <- matrix(subset(value, subset=con%in%1:model.nn$n[1])$w,
              ncol=model.nn$n[1], byrow=TRUE)
h2o <- matrix(subset(value, subset=con%in%(1:model.
              nn$n[2]+model.nn$n[1]))$w, ncol=model.nn$n[2], byrow=TRUE)
M <- matrix(0, nrow=sum(model.nn$n), ncol=sum(model.nn$n),
            dimnames=list(unlist(name),unlist(name)))
M[name[[2]], name[[1]]] <- i2h
M[name[[3]], name[[2]]] <- h2o
diag(M[unlist(name[-1]),
       unlist(name[-1])]) <- subset(value, subset=con==0)$w
box.type <- ifelse(sub("[[:digit:]]", "", colnames(M))=="h",
                       "circle", "diamond")
arr.lcol <- ifelse(M>0, rgb(red=0, blue=1, green=0, alpha=.3),
                        rgb(red=1, blue=0, green=0, alpha=.3))
arr.lwd <- log10(abs(M)+1)+1
plotmat(round(M,2), pos=model.nn$n, curve=0,
        box.type=box.type, box.prop=.5, self.lwd=0
        self.shiftx=-.1, self.arrpos=0, arr.pos=.6, arr.length=0,
        arr.lcol=arr.lcol, arr.lwd=arr.lwd, cex.txt=.8)
