# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# plm.R
# 20110425


## 1Fpl`A
library(plm)
data("Produc", package = "plm")

print(Produc[1:5, ])

pdim(Produc, index = c("state", "year"))

zz <- plm(log(gsp) ~ log(pcap) + log(pc) + log(emp) + unemp,
          data = Produc,
          index = c("state", "year"))
summary(zz) # ʂ\

zz0 <- lm(log(gsp) ~ state + log(pcap) + log(pc) + log(emp) +
          unemp, data = Produc)

zz1 <- plm(log(gsp) ~ log(pcap) + log(pc) + log(emp) + unemp,
           data = Produc, effect = "time",
           index = c("state", "year"))

zzr <- plm(log(gsp) ~ log(pcap) + log(pc) + log(emp) + unemp,
           data = Produc, model = "random",
           index = c("state", "year"))

zz2 <- lm(log(gsp) ~ log(pcap) + log(pc) + log(emp) + unemp,
          data = Produc)

zzb <- plm(log(gsp) ~ log(pcap) + log(pc) + log(emp) + unemp,
           data = Produc, model = "between",
           index = c("state", "year"))

lgdp_m <- c(); lpcap_m <- c(); lpc_m <- c(); lemp_m <- c()
unemp_m <- c()
states <- union(Produc$state, Produc$state)
for (i in 1:length(states)) {
  ss <- which(Produc$state == states[i])
  lgdp_m[i] <- mean(log(Produc[ss, ]$gsp))
  lpcap_m[i] <- mean(log(Produc[ss, ]$pcap))
  lpc_m[i] <- mean(log(Produc[ss, ]$pc))
  lemp_m[i] <- mean(log(Produc[ss, ]$emp))
  unemp_m[i] <- mean(Produc[ss, ]$unemp)
}
zz3 <- lm(lgdp_m ~ lpcap_m + lpc_m + lemp_m + unemp_m)

zzf <- plm(log(gsp) ~ log(pcap) + log(pc) + log(emp) + unemp,
           data = Produc, model = "fd",
           index = c("state", "year"))

dlog_gdp<- c(); dlog_pcap <- c(); dlog_pc <- c()
dlog_emp <- c(); dunemp <- c()
states <- union(Produc$state, Produc$state)
for (i in 1:length(states)) {
  tt <- (i-1)*16 + 1:16
  ss <- which(Produc$state == states[i])
  dlog_gdp[tt] <- log(Produc[ss, ]$gsp[-1]) - log(Produc[ss, ]$gsp[-17])
  dlog_pcap[tt] <- log(Produc[ss, ]$pcap[-1]) - log(Produc[ss, ]$pcap[-17])
  dlog_pc[tt] <- log(Produc[ss, ]$pc[-1]) - log(Produc[ss, ]$pc[-17])
  dlog_emp[tt] <- log(Produc[ss, ]$emp[-1]) - log(Produc[ss, ]$emp[-17])
  dunemp[tt] <- Produc[ss, ]$unemp[-1] - Produc[ss, ]$unemp[-17]
}
zz4 <- lm(dlog_gdp ~ dlog_pcap + dlog_pc + dlog_emp + dunemp)


## 2FHausman 
data("Produc", package = "plm")
form <- log(gsp) ~ log(pcap) + log(pc) + log(emp) + unemp
# fixed effects model
fe <- plm(form, data = Produc, index = c("state","year"))
# random effects model
re <- plm(form, data = Produc, model = "random",
          index = c("state","year"))
phtest(fe, re)

phtest(fe, re)
