# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# snow.R
# 20110425


library(snow)


## bIȕ
hosts <- rep("localhost", 4)
cl <- makeCluster(hosts, type="SOCK")

x <- 1
clusterExport(cl, "x")

clusterCall(cl, function(y){ x + y }, 2)

clusterEvalQ(cl, library(boot))

clusterApply(cl, 1:8, get("+"), 3)

A <- matrix(rep(1:4, 4), 4)
A
parMM(cl, A, A)

parApply(cl, A, c(1, 2), function(x){ x^2 })

parRapply(cl, A, sum)
parCapply(cl, A, sum)

stopCluster(cl)


## ̗p
hosts <- rep("localhost", 2)
cl <- makeCluster(hosts, type="SOCK")
clusterCall(cl, runif, 3)

clusterSetupRNG(cl, type="RNGstream")
clusterCall(cl, runif, 3)
stopCluster(cl)


## u[gXgbv@̕
wallTime <- function(expr) { system.time(expr)[3] }

library(boot)
nuke <- nuclear[,c(1,2,5,7,8,10,11)]
nuke.lm <- glm(log(cost)~date+log(cap)+ne+ ct+log(cum.n)+pt, data=nuke)
nuke.diag <- glm.diag(nuke.lm)
nuke.res <- nuke.diag$res*nuke.diag$sd
nuke.res <- nuke.res-mean(nuke.res)
nuke.data <- data.frame(nuke,resid=nuke.res,fit=fitted(nuke.lm))
new.data <- data.frame(cost=1, date=73.00, cap=886, ne=0,
                       ct=0, cum.n=11, pt=1)
new.fit <- predict(nuke.lm, new.data)
nuke.fun <- function(dat, inds, i.pred, fit.pred, x.pred) {
                      assign(".inds", inds, envir=.GlobalEnv)
                      lm.b <- glm(fit+resid[.inds] ~date+log(cap)+ne+ct+
                      log(cum.n)+pt, data=dat)
                      pred.b <- predict(lm.b,x.pred)
                      remove(".inds", envir=.GlobalEnv)
                      c(coef(lm.b), pred.b-(fit.pred+dat$resid[i.pred]))
}

wallTime(boot(nuke.data, nuke.fun, R=1000, m=1,
    fit.pred=new.fit, x.pred=new.data))

hosts <- rep("localhost", 4)
cl <- makeCluster(hosts, type="SOCK")
clusterSetupRNG(cl, type="RNGstream")
clusterEvalQ(cl, library(boot))

wallTime(clusterCall(cl, boot, nuke.data, nuke.fun, R=250, m=1,
    fit.pred=new.fit, x.pred=new.data))
stopCluster(cl)
