# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# spgrass6.R
# 20110425


## R ̒GRASS NĐVZbVJn
library(spgrass6)
## L͂܂łłB̊ɍ킹ĂB
gisBaseWin <- "C:/Program Files/GRASS-64"
gisBaseMac <- "/opt/local/share/grass-6.4.0RC6/"
gisBaseUnix <- "/usr/lib/grass64/"
initGRASS(gisBase = gisBaseUnix, home = tempdir())


## ŒZoȞvZ
gisDbaseWin <- "C:/tmp"
gisDbaseMac <- "/tmp"
gisDbaseUnix <- "/tmp"

library(spgrass6)
initGRASS(gisBase = gisBaseUnix, home = tempdir(),
          gisDbase = gisDbaseUnix, location = "spearfish60",
          mapset = "test", override = TRUE)

# {GRASS gꍇ܂͓{ɋNG[oꍇ
Sys.setenv(LANG = "C")

# {Windows gꍇ܂͓{ɋNG[oꍇ
Sys.setenv(LANGUAGE = "en_US")

r1 <- readVECT6("roads", ignore.stderr = TRUE)

label <- r1[["label"]]
dat <- data.frame(label, forward = 1/50, backward = 1/50)
type <- C("interstate", "unimproved road",
          "light-duty road, improved surface")
dat$forward[dat$label == type[1]] <- 1/75
dat$backward[dat$label == type[1]] <- 1/75
dat$forward[dat$label == type[2]] <- 1/5
dat$backward[dat$label == type[2]] <- 1/5
dat$forward[dat$label == type[3]] <- 1/5
dat$backward[dat$label == type[3]] <- 1/5
r1@data <- cbind(r1@data, dat[, 2:3])

writeVECT6(r1, "myroads", v.in.ogr_flags = c("o",
           "overwrite"), ignore.stderr = TRUE)

sted <- data.frame(x = c(601653.5, 593330.8),
                   y = c(4922869.2, 4924096.6))
coordinates(sted) <- ~x + y
sted.df <- SpatialPointsDataFrame(sted, data.frame(v = 1:2))

writeVECT6(sted.df, "startend", v.in.ogr_flags = c("o",
           "overwrite"), ignore.stderr = TRUE)

para <- list(input = "myroads", points = "startend",
             output = "myroad_net",
             operation = "connect", thresh = 200)
execGRASS("v.net", flags = c("overwrite"), parameters = para)
execGRASS("g.region", parameters = list(vect = "myroad_net"))

cat("1 1 2", file = "input.txt")
execGRASS("v.net.path", flags = c("overwrite"),
    parameters = list(input = "myroad_net",
        afcolumn = "forward",
        abcolumn = "backward", output = "mypath",
        file = "input.txt"))

res <- readVECT6("mypath", ignore.stderr = TRUE)
plot(r1, col = "gray")
plot(sted, col = "red", pch = 4, cex = 2, lwd = 2, add = TRUE)
plot(res, col = "blue", lwd = 5, add = TRUE)
