# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# systemfit.R
# 20110425


library(systemfit)
data(Kmenta)
head(Kmenta)

eqDemand <- consump ~ price + income # v֐
eqSupply <- consump ~ price + farmPrice + trend # ֐
eqSystem <- list(demand = eqDemand, supply = eqSupply)

fitols <- systemfit(eqSystem, data=Kmenta)
print(fitols)

lm(eqDemand, data=Kmenta)
lm(eqSupply, data=Kmenta)

fitsur <- systemfit(eqSystem, method = "SUR", data = Kmenta)
print(fitsur)

fit2sls <- systemfit(eqSystem, method = "2SLS",
                     inst = ~income + farmPrice + trend, data = Kmenta)
summary(fit2sls)

fit3sls <- systemfit(eqSystem, method = "3SLS",
             inst = list(~farmPrice + trend, ~income + farmPrice + trend),
             data = Kmenta)
summary(fit3sls)

summary(fit3sls, residCov = FALSE, equations = FALSE)
